<?php
if ($goto=="lastpost" or $goto=="newpost") {
  $noheader=1;
}
require("global.php");

// oldest first or newest first
if ($postsorder==0) {
  $postorder="";
} else {
  $postorder="DESC";
}

if ($goto=="lastpost") {
  if (isset($forumid)==1 and $forumid!=0) {
    $forumid = verifyid("forum",$forumid);

    if ($getlastpost=$DB_site->query_first("SELECT postid,post.dateline FROM post,thread WHERE post.threadid=thread.threadid AND thread.forumid=$forumid AND post.visible=1 ORDER BY post.dateline DESC LIMIT 1")) {
      header("Location: showthread.php?postid=$getlastpost[postid]#post$getlastpost[postid]");
      exit;
    }
  }
  if (isset($threadid)==1 and $threadid!=0) {
    $threadid = verifyid("thread",$threadid);

    if ($getlastpost=$DB_site->query_first("SELECT postid,post.dateline FROM post,thread WHERE post.threadid=thread.threadid AND thread.threadid=$threadid AND post.visible=1 ORDER BY post.dateline DESC LIMIT 1")) {
      header("Location: showthread.php?postid=$getlastpost[postid]#post$getlastpost[postid]");
      exit;
    }
  }

}
if ($goto=="newpost") {
  $threadid = verifyid("thread",$threadid);

  if ($posts=$DB_site->query_first("SELECT postid,dateline FROM post WHERE post.threadid=$threadid AND post.visible=1 AND post.dateline>$bblastvisit ORDER BY dateline LIMIT 1")) {
    header("Location: showthread.php?postid=$posts[postid]#post$posts[postid]");
    exit;
  } else {
    header("Location: showthread.php?threadid=$threadid&goto=lastpost");
    exit;
  }
}

if (isset($perpage)==0 or $perpage==0) {
  $perpage=$maxposts;
}

if (isset($postid)!=0 and $postid!=0 and $postid!="") {
  $postid = verifyid("post",$postid);

  $getthread=$DB_site->query_first("SELECT threadid FROM post WHERE postid=$postid");
  $threadid=$getthread[threadid];

  $getpagenum=$DB_site->query_first("SELECT COUNT(postid) AS posts FROM post WHERE threadid=$threadid AND postid<=$postid");
  if ($getpagenum[posts]%$perpage==0) {
    $pagenumber=$getpagenum[posts]/$perpage;
  } else {
    $pagenumber=intval($getpagenum[posts]/$perpage)+1;
  }
}

$threadid = verifyid("thread",$threadid);

$threadinfo=$DB_site->query_first("SELECT title,forumid,open,lastpost,replycount+1 AS posts,views,visible FROM thread WHERE threadid=$threadid");
if ($wordwrap!=0) {
  $threadinfo[title]=dowordwrap($threadinfo[title]);
}
$threadtitle=htmlspecialchars($threadinfo[title]);
$forumid=$threadinfo[forumid];
$views=$threadinfo[views];

if ($threadinfo[visible]==0) {
  $idname="thread";
  eval("echo standarderror(\$bbtitle,\"".gettemplate("error_invalidid")."\");");
}

$getperms=getpermissions($bbuserid,$bbusergroupid,$forumid);
if ($getperms[canview]==0) {
  eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
  exit;
}

if ((isset($pagenumber)==0 or $pagenumber==0) and $pagenumber!="lastpage") {
  $pagenumber=1;
}

$DB_site->query("UPDATE thread SET views=views+1 WHERE threadid=$threadid");

makeforumjump();

$foruminfo=$DB_site->query_first("SELECT title,description,categoryid,active,titleimage,threadtemplate,threadbittemplate,replyimage,newthreadimage,closedthreadimage,headertemplate,useadvheader,footertemplate,useadvfooter,rulestemplate,allowbbcode,allowimages,allowhtml,allowsmilies FROM forum WHERE forumid=$forumid");
$forumtitle=htmlspecialchars($foruminfo[title]);
if ($foruminfo[titleimage]!="") {
  $titleimage=$foruminfo[titleimage];
}
if ($foruminfo[threadtemplate]!="") {
  $usetemplate=$foruminfo[threadtemplate];
} else {
  $usetemplate="showthread";
}
if ($foruminfo[threadbittemplate]!="") {
  $usetemplatebit=$foruminfo[threadbittemplate];
} else {
  $usetemplatebit="postbit";
}
if ($foruminfo[replyimage]!="") {
  $replyimage=$foruminfo[replyimage];
}
if ($foruminfo[newthreadimage]!="") {
  $newthreadimage=$foruminfo[newthreadimage];
}
if ($foruminfo[closedthreadimage]!="") {
  $closedthreadimage=$foruminfo[closedthreadimage];
}

$bbcodeon=iif($foruminfo[allowbbcode]==1,$ontext,$offtext);
$imgcodeon=iif($foruminfo[allowimages]==1,$ontext,$offtext);
$htmlcodeon=iif($foruminfo[allowhtml]==1,$ontext,$offtext);
$smilieson=iif($foruminfo[allowsmilies]==1,$ontext,$offtext);
if ($foruminfo[rulestemplate]!="") {
  eval("\$forumrules = \"".gettemplate("$foruminfo[rulestemplate]")."\";");
} else {
  eval("\$forumrules = \"".gettemplate("forumrules")."\";");
}

$getcategory=$DB_site->query_first("SELECT title,categoryid FROM category WHERE category.categoryid=$foruminfo[categoryid]");
$categorytitle=$getcategory[title];
$categoryid=$getcategory[categoryid];

if ($foruminfo[active]==0) {
  echo standarderror($bbtitle,gettemplate("error_forumclosed",0));
  exit;
}

if ($threadinfo[posts]>$perpage) {

  $totalpages=$threadinfo[posts]/$perpage;
  if ($totalpages!=intval($totalpages)) {
    $totalpages=intval($totalpages)+1;
  }

  if ($pagenumber=="lastpage") {
    $pagenumber=$totalpages;
  }

  eval("\$pagenav = \"".gettemplate("showthread_numpages")."\";");

  $curpage=0;
  while ($curpage++<$totalpages) {

    if (($curpage<$pagenumber-$pagenavpages or $curpage>$pagenumber+$pagenavpages) and $pagenavpages!=0) {
      if ($curpage==1) {
        $pagenav.=" <a href=\"showthread.php?threadid=$threadid&pagenumber=$curpage".iif($perpage==$maxposts,"","&perpage=$perpage")."\"><font color=\"{tableheadtextcolor}\" class=thtcolor>&lt;&lt; First Page</font></a>&nbsp;&nbsp; ...&nbsp;&nbsp;";
      }
      if ($curpage==$totalpages) {
        $pagenav.=" ...&nbsp;&nbsp; <a href=\"showthread.php?threadid=$threadid&pagenumber=$curpage".iif($perpage==$maxposts,"","&perpage=$perpage")."\"><font color=\"{tableheadtextcolor}\" class=thtcolor>Last Page &gt;&gt;</font></a>&nbsp;&nbsp;";
      }
    } else {
      if ($curpage==$pagenumber) {
        $pagenav.=" <font color=\"{tableheadtextcolor}\" class=thtcolor>$curpage</font>&nbsp;&nbsp;";
      } else {
        $pagenav.=" <a href=\"showthread.php?threadid=$threadid&pagenumber=$curpage".iif($perpage==$maxposts,"","&perpage=$perpage")."\"><font color=\"{tableheadtextcolor}\" class=thtcolor>$curpage</font></a>&nbsp;&nbsp;";
      }
    }
  }
} else {

  if ($pagenumber=="lastpage") {
    $pagenumber=1;
  }

}

$limitlower=($pagenumber-1)*$perpage;

$counter=0;
$posts=$DB_site->query("SELECT dateline,postid,pagetext,allowsmilie,signature AS showsignature,title,ipaddress,iconid,username,userid FROM post WHERE threadid=$threadid AND visible=1 ORDER BY dateline $postorder LIMIT $limitlower,$perpage");
while ($post=$DB_site->fetch_array($posts)) {

  $counter++;

  $postid=$post[postid];

  if ($counter%2==0) {
    $backcolor="{firstaltcolor}";
  } else {
    $backcolor="{secondaltcolor}";
  }

  // find first new post
  if (isset($bblastvisit)!=0) {
    if ($post[dateline]>$bblastvisit and $firstnew==0) {
      $firstnew=1;
      $firstnewname="<a name=\"newpost\"></a>";
    } else {
      $firstnewname="";
    }
  }

  $postdate=date($dateformat,$post[dateline]+(($timeoffset+$bbtimezoneoffset)*3600));
  $posttime=date($timeformat,$post[dateline]+(($timeoffset+$bbtimezoneoffset)*3600));

  if ($wordwrap!=0) {
    $post[title]=dowordwrap($post[title]);
  }
  $postitle=htmlspecialchars($post[title]);

  if ($post[dateline]>$bblastvisit) {
    $foldericon="<IMG SRC=\"images/posticonnew.gif\" BORDER=0>";
  } else {
    $foldericon="<IMG SRC=\"images/posticon.gif\" BORDER=0>";
  }
  if ($showicons==0 or $post[iconid]==0) {
    $posticon="";
  } else {
    if ($icon=$DB_site->query_first("SELECT title,iconpath FROM icon WHERE iconid=$post[iconid]")) {
      $posticon="<img src=\"$icon[iconpath]\" alt=\"$icon[title]\" border=0>";
    } else {
      $posticon="";
    }
  }

  $userid=$post[userid];

  if ($userid!=0) {
    $userinfo=$DB_site->query_first("SELECT userid,email,username,usertitle,signature,showemail,homepage,icq,aim,yahoo,joindate,posts FROM user WHERE userid=$userid");

    $username=htmlspecialchars($userinfo[username]);
    $searchuser=urlencode($userinfo[username]);
    $usertitle=$userinfo[usertitle];
    $userjoindate=date($registereddateformat,$userinfo[joindate]+(($timeoffset+$bbtimezoneoffset)*3600));
    $userpostcount=$userinfo[posts];

    if ($userinfo[showemail]==1 and $displayemails==1) {
      $email=$userinfo[email];
      eval("\$useremail = \"".gettemplate("postbit_useremail")."\";");
    } else {
      $email="";
      $useremail="";
    }
    if ($userinfo[icq]!="") {
      $icqnumber=$userinfo[icq];
      eval("\$icq = \"".gettemplate("icq")."\";");
    } else {
      $icqnumber="";
      $icq="";
    }
    if ($userinfo[aim]!="") {
      $aimhandle=$userinfo[aim];
      eval("\$aim = \"".gettemplate("aim")."\";");
    } else {
      $aimhandle="";
      $aim="";
    }
    if ($userinfo[yahoo]!="") {
      $yahoohandle=$userinfo[yahoo];
      eval("\$yahoo = \"".gettemplate("yahoo")."\";");
    } else {
      $yahoohandle="";
      $yahoo="";
    }

    if ($userinfo[homepage]!="" and $userinfo[homepage]!="http://") {
      $homepageurl=$userinfo[homepage];
      eval("\$homepage = \"".gettemplate("postbit_homepage")."\";");
    } else {
      $homepageurl="";
      $homepage="";
    }

    eval("\$profile = \"".gettemplate("postbit_profile")."\";");
    $findposts="";

    if ($post[showsignature]==1 and $allowsignatures==1 and trim($userinfo[signature])!="") {
      $signature= "\n__________________\n$userinfo[signature]";
    } else {
      $signature="";
    }
  } else {
    $username=htmlspecialchars($post[username]);
    $searchuser=urlencode($post[username]);
    $usertitle="Guest";
    $userjoindate="Not Yet";
    $userpostcount="N/A";

    $profile="";
    $userlocation="";
    $email="";
    $useremail="";
    $icqhandle="";
    $icq="";
    $aimhandle="";
    $aim="";
    $yahoohandle="";
    $yahoo="";
    $homepageurl="";
    $homepage="";
    $searchuser="";
    $findposts="";
    $signature="";

  }

  if ($post[ipaddress]!="") {
    if ($logip==2) {
      $iplogged="IP: $post[ipaddress]";
    }
    if ($logip==1) {
      $iplogged="IP: <a href=\"postings.php?action=getip&postid=$postid\">Logged</a>";
    }
    if ($logip==0) {
      $iplogged="";
    }
  } else {
    $iplogged="";
  }

  $message=bbcodeparse($post[pagetext],$forumid,$post[allowsmilie]).bbcodeparse($signature,0,$allowsmilies);

  eval("\$postbits .= \"".gettemplate("$usetemplatebit")."\";");

}

if ($threadinfo[lastpost]>$bblastvisit) {
  // do blue arrow link
  $counter=0;
  $posts=$DB_site->query("SELECT postid,dateline FROM post WHERE post.threadid=$threadid AND post.visible=1 ORDER BY dateline $postorder");
  while ($post=$DB_site->fetch_array($posts)) {

    $counter++;

    if ($post[dateline]>$bblastvisit) {
      if ($counter%$perpage==0) {
        $firstnewpagenum=intval($counter/$perpage);
      } else {
        $firstnewpagenum=intval($counter/$perpage)+1;
      }
      if ($firstnewpagenum==$pagenumber) {
        $newpostlink="#newpost";
      } else {
        $newpostlink="showthread.php?threadid=$threadid&pagenumber=$firstnewpagenum#newpost";
      }
      break;
    }
  }

  if ($newpostlink=="") {
    $firstunread="";
  } else {
    eval("\$firstunread = \"".gettemplate("firstunread")."\";");
  }
} else {
  $firstunread="";
}

if ($getnextnewest=$DB_site->query_first("SELECT threadid FROM thread WHERE lastpost>$threadinfo[lastpost] AND forumid=$forumid AND visible=1 ORDER BY lastpost LIMIT 1")) {
  $nextnewestthreadid=$getnextnewest[threadid];
  eval("\$nextnewest = \"".gettemplate("showthread_nextnewestthread")."\";");
} else {
  $nextnewestthreadid=$threadid;
}

if ($getnextoldest=$DB_site->query_first("SELECT threadid FROM thread WHERE lastpost<$threadinfo[lastpost] AND forumid=$forumid AND visible=1 ORDER BY lastpost DESC LIMIT 1")) {
  $nextoldestthreadid=$getnextoldest[threadid];
  eval("\$nextoldest = \"".gettemplate("showthread_nextoldestthread")."\";");
} else {
  $nextoldestthreadid=$threadid;
}

if ($threadinfo[open]==1) {
  $replyclose="$replyimage";
} else {
  $replyclose="$closedthreadimage";
}

// parse header ##################
if ($foruminfo[headertemplate]!="") {
  if ($foruminfo[useadvheader]==1) {
    eval(gettemplate("$foruminfo[headertemplate]").";");
  } else {
    eval("\$header = \"".gettemplate("$foruminfo[headertemplate]")."\";");
  }
}
if ($foruminfo[footertemplate]!="") {
  if ($foruminfo[useadvfooter]==1) {
    eval(gettemplate("$foruminfo[footertemplate]").";");
  } else {
    eval("\$footer = \"".gettemplate("$foruminfo[footertemplate]")."\";");
  }
}

eval("echo dovars(\"".gettemplate("$usetemplate")."\");");

?>