<?php
require("global.php");

// oldest first or newest first
if ($postsorder==0) {
  $postorder="";
} else {
  $postorder="DESC";
}

$threadid = verifyid("thread",$threadid);

$threadinfo=$DB_site->query_first("SELECT title,forumid,open,lastpost,replycount+1 AS posts,visible FROM thread WHERE threadid=$threadid");
if ($wordwrap!=0) {
  $threadinfo[title]=dowordwrap($threadinfo[title]);
}
$threadtitle=htmlspecialchars($threadinfo[title]);
$forumid=$threadinfo[forumid];

if ($threadinfo[visible]==0) {
  $idname="thread";
  eval("echo standarderror(\$bbtitle,\"".gettemplate("error_invalidid")."\");");
}

$getperms=getpermissions($bbuserid,$bbusergroupid,$forumid);
if ($getperms[canview]==0) {
  eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
  exit;
}

$foruminfo=$DB_site->query_first("SELECT title,description,active,titleimage,threadtemplate,threadbittemplate,replyimage,newthreadimage,closedthreadimage,headertemplate,useadvheader,footertemplate,useadvfooter,rulestemplate,allowbbcode,allowimages,allowhtml,allowsmilies FROM forum WHERE forumid=$forumid");
$forumtitle=htmlspecialchars($foruminfo[title]);
if ($foruminfo[titleimage]!="") {
  $titleimage=$foruminfo[titleimage];
}

if ($foruminfo[active]==0) {
  echo standarderror($bbtitle,gettemplate("error_forumclosed",0));
  exit;
}

$counter=0;
$posts=$DB_site->query("SELECT dateline,postid,pagetext,allowsmilie,signature AS showsignature,title,ipaddress,iconid,username,userid FROM post WHERE threadid=$threadid AND visible=1 ORDER BY dateline $postorder");
while ($post=$DB_site->fetch_array($posts)) {

  $counter++;

  $postid=$post[postid];

  $postdate=date($dateformat,$post[dateline]+(($timeoffset+$bbtimezoneoffset)*3600));
  $posttime=date($timeformat,$post[dateline]+(($timeoffset+$bbtimezoneoffset)*3600));
  $posttitle=htmlspecialchars($post[title]);

  if ($showicons==0 or $post[iconid]==0) {
    $posticon="";
  } else {
    if ($icon=$DB_site->query_first("SELECT title,iconpath FROM icon WHERE iconid=$post[iconid]")) {
      $posticon="<img src=\"$icon[iconpath]\" alt=\"$icon[title]\" border=0>";
    } else {
      $posticon="";
    }
  }

  $userid=$post[userid];

  if ($userid!=0) {
    $userinfo=$DB_site->query_first("SELECT userid,email,username,usertitle,signature,showemail,homepage,icq,aim,yahoo,joindate,posts FROM user WHERE userid=$userid");

    $username=htmlspecialchars($userinfo[username]);
    $usertitle=$userinfo[usertitle];
    $userjoindate=date($registereddateformat,$userinfo[joindate]+(($timeoffset+$bbtimezoneoffset)*3600));
    $userpostcount=$userinfo[posts];

    if ($userinfo[showemail]==1 and $displayemails==1) {
      eval("\$useremail = \"".gettemplate("postbit_useremail")."\";");
    } else {
      $useremail="";
    }
    if ($userinfo[icq]!="") {
      $icqnumber=$userinfo[icq];
      eval("\$icq = \"".gettemplate("icq")."\";");
    } else {
      $icq="";
    }
    if ($userinfo[aim]!="") {
      $aimhandle=$userinfo[aim];
      eval("\$aim = \"".gettemplate("aim")."\";");
    } else {
      $aim="";
    }
    if ($userinfo[yahoo]!="") {
      $yahoohandle=$userinfo[yahoo];
      eval("\$yahoo = \"".gettemplate("yahoo")."\";");
    } else {
      $yahoo="";
    }

    if ($userinfo[homepage]!="" and $userinfo[homepage]!="http://") {
      $homepageurl=$userinfo[homepage];
      eval("\$homepage = \"".gettemplate("postbit_homepage")."\";");
    } else {
      $homepage="";
    }

    eval("\$profile = \"".gettemplate("postbit_profile")."\";");
    $findposts="";

    if ($post[showsignature]==1 and $allowsignatures==1 and $userinfo[signature]!="") {
      $signature= "\n__________________\n$userinfo[signature]";
    } else {
      $signature="";
    }
  } else {
    $username=htmlspecialchars($post[username]);
    $usertitle="Guest";
    $userjoindate="Not Yet";
    $userpostcount="N/A";

    $profile="";
    $userlocation="";
    $useremail="";
    $icq="";
    $homepage="";
    $searchuser="";
    $findposts="";
    $signature="";

  }

  if ($post[ipaddress]!="") {
    if ($logip==2) {
      $iplogged="IP: $post[ipaddress]";
    }
    if ($logip==1) {
      $iplogged="IP: <a href=\"postings.php?action=getip&postid=$postid\">Logged</a>";
    }
    if ($logip==0) {
      $iplogged="";
    }
  } else {
    $iplogged="";
  }

  $message=bbcodeparse($post[pagetext],$forumid,$post[allowsmilie]).bbcodeparse($signature,0,$allowsmilies);

  $searchuser=urlencode($username);

  eval("\$postbits .= \"".gettemplate("printthreadbit")."\";");

}

eval("echo dovars(\"".gettemplate("printthread")."\");");

?>